import os
import subprocess

from dotenv import load_dotenv
from flask import Flask, jsonify, request


def create_app():
    load_dotenv()
    app = Flask(__name__)

    @app.route("/", methods=["POST"])
    def deploy():
        if request.headers["Authorization"] != f'Bearer {os.getenv("TOKEN")}':
            return jsonify({"message": "Invalid token"}), 401
        subprocess.run(["git", "pull"], cwd=os.getenv("FOLDER"))
        subprocess.run(["git", "checkout", "gh-pages"], cwd=os.getenv("FOLDER"))
        return jsonify({"message": "Deployed"}), 200

    return app
